import { defHttp } from '/@/utils/http/axios';
import { useMessage } from '/@/hooks/web/useMessage';

const { createConfirm } = useMessage();

enum Api {
  list = '/oroqen/cultureContent/list',
  save = '/oroqen/cultureContent/add',
  edit = '/oroqen/cultureContent/edit',
  deleteOne = '/oroqen/cultureContent/delete',
  deleteBatch = '/oroqen/cultureContent/deleteBatch',
  importExcel = '/oroqen/cultureContent/importExcel',
  exportXls = '/oroqen/cultureContent/exportXls',
  queryById = '/oroqen/cultureContent/queryById',
  recommend = '/oroqen/cultureContent/recommend',
  cancelRecommend = '/oroqen/cultureContent/cancelRecommend',
}

/**
 * 导出api
 */
export const getExportUrl = Api.exportXls;

/**
 * 导入api
 */
export const getImportUrl = Api.importExcel;

/**
 * 列表接口
 */
export const list = (params) => defHttp.get({ url: Api.list, params });

/**
 * 删除单个
 */
export const deleteOne = (params, handleSuccess) => {
  return defHttp.delete({ url: Api.deleteOne, params }, { joinParamsToUrl: true }).then(() => {
    handleSuccess();
  });
};

/**
 * 批量删除
 */
export const batchDelete = (params, handleSuccess) => {
  createConfirm({
    iconType: 'warning',
    title: '确认删除',
    content: '是否删除选中数据',
    okText: '确认',
    cancelText: '取消',
    onOk: () => {
      return defHttp.delete({ url: Api.deleteBatch, data: params }, { joinParamsToUrl: true }).then(() => {
        handleSuccess();
      });
    }
  });
};

/**
 * 保存或者更新
 */
export const saveOrUpdate = (params, isUpdate) => {
  let url = isUpdate ? Api.edit : Api.save;
  return defHttp.post({ url: url, params });
};

/**
 * 推荐/取消推荐
 */
export const toggleRecommend = (id: string, isRecommend: boolean) => {
  const url = isRecommend ? Api.recommend : Api.cancelRecommend;
  return defHttp.post({ url: `${url}/${id}` });
};